﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Timers;

namespace WaitDialog.ViewModel
{
    class MyVM : INotifyPropertyChanged
    {
        private bool _isBusy;
        private Timer _timer = new Timer(5000);

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        public MyVM()
        {
            IsBusy = true;
            _timer.Elapsed += new ElapsedEventHandler(_timer_Elapsed);
            _timer.AutoReset = true;
            _timer.Start();
        }

        void _timer_Elapsed(object sender, ElapsedEventArgs e)
        {
            IsBusy = !IsBusy;
        }

        public bool IsBusy
        {
            get
            {
                return _isBusy;
            }
            set
            {
                _isBusy = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("IsBusy"));
                    PropertyChanged(this, new PropertyChangedEventArgs("IsFree"));
                }
            }
        }

        public bool IsFree
        {
            get
            {
                return !IsBusy;
            }
            set
            {
                IsBusy = !value;
            }
        }

        public string MyString { get; set; }
    }
}
